Bug 512026 - DHCPD not honoring host declaration
DHCPD not honoring host declaration
Status: CLOSED NOTABUG
Product: Fedora
Classification: Fedora
Component: dhcp (Show other bugs)
11
x86_64 Linux
low Severity medium
: ---
: ---
Assigned To: David Cantrell
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-07-15 19:58 EDT by Matt Castelein
Modified: 2009-08-18 19:13 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-08-06 16:43:48 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
dhcpd.conf (2.01 KB, text/plain)
2009-08-05 10:10 EDT, Matt Castelein
no flags Details
Log file (776 bytes, text/plain)
2009-08-05 22:35 EDT, Matt Castelein
no flags Details
Packet capture (1.44 KB, application/octet-stream)
2009-08-05 22:36 EDT, Matt Castelein
no flags Details

  None (edit)
Description Matt Castelein 2009-07-15 19:58:37 EDT
I have a host declaration as follows:

# NETGEAR FS726T
host switch3 {
	hardware ethernet 00:14:6c:37:f7:05;
	fixed-address 192.168.1.11;
	}

Yet, dhcpd will not assign it to this address, instead creating the following lease:

lease 192.168.1.101 {
  starts 3 2009/07/15 23:46:35;
  ends 4 2009/07/16 11:46:35;
  cltt 3 2009/07/15 23:46:35;
  binding state active;
  next binding state free;
  hardware ethernet 00:14:6c:37:f7:05;
}

I have restarted the server, rebooted the server, deleted the lease file, rebooted the switch, reset the switch to factory several times but I cannot get it assigned to .11 - What gives?
Comment 1 Matt Castelein 2009-07-16 19:30:26 EDT
This client is sending a request with option 50 to grab an ip that's not the one I've assigned.  Why is the DHCP server not ignoring this request and using the host declaration specified?
Comment 2 David Cantrell 2009-08-04 22:36:50 EDT
Can you attach your entire dhcpd.conf file?
Comment 3 Matt Castelein 2009-08-05 10:10:07 EDT
Created attachment 356321 [details]
dhcpd.conf
Comment 4 David Cantrell 2009-08-05 16:58:40 EDT
Do you have a dhclient.conf or dhclient-ethX.conf file on the client device?
Comment 5 Matt Castelein 2009-08-05 17:04:22 EDT
(In reply to comment #4)
> Do you have a dhclient.conf or dhclient-ethX.conf file on the client device?  

No, it's just a 24 port switch.
Comment 6 David Cantrell 2009-08-05 21:07:12 EDT
Can you stop dhcpd and run it in the foreground with debugging enabled?  Then try the client and see what happens.  Attach the log file to this bug report.

On the server:
dhcpd -f -d [interface] 2>&1 | tee dhcpd.log

Where [interface] is something like eth0 or eth1.  Once the client has received an IP address, stop the server with Ctrl+C and then attach dhcpd.log to this bug and I'll see what I can do with that.
Comment 7 Matt Castelein 2009-08-05 22:35:56 EDT
Created attachment 356450 [details]
Log file
Comment 8 Matt Castelein 2009-08-05 22:36:41 EDT
Created attachment 356451 [details]
Packet capture

Here is a packet capture just for giggles.
Comment 9 David Cantrell 2009-08-05 22:49:29 EDT
It looks like the cause is this line in your dhcpd.conf file:

range dynamic-bootp 192.168.1.101 192.168.1.254;

The dynamic-bootp flag, specifically.  From the dhcpd.conf man page:

"The dynamic-bootp flag may be specified if addresses in the specified range may be dynamically assigned to BOOTP clients as well as DHCP clients."

My guess is the Netgear switch is trying BOOTP first, getting 192.168.1.101 (which is correct by your config) and subsequently keeping that and requesting it as a DHCP lease from the server.

Remove 'dynamic-bootp' and see if it succeeds.
Comment 10 Matt Castelein 2009-08-06 08:22:45 EDT
(In reply to comment #9)
> Remove 'dynamic-bootp' and see if it succeeds.  

That had no effect at all.  The server is still giving the switch .101 instead of .11.. It's worth noting that the host "printer2" is also BOOTP, and gets the correct .10 address every time.
Comment 11 David Cantrell 2009-08-06 16:43:48 EDT
The only other idea I have is to remove 'allow bootp' and see if the Netgear switch works with that.  My guess is the client is at fault here, or at least doing something you are unaware of.  Beyond trying different settings in dhcpd.conf, there's not much I can do.

If you do find a working set of options in dhcpd.conf, you can play around with the 'group' keyword and set it up so you have a group just for the Netgear switch that has the settings that make it work.

Since this is really a configuration issue with a blackbox client, I can't do much.  Closing this bug as CANTFIX.
Comment 12 Matt Castelein 2009-08-09 16:54:09 EDT
I have opened a case with Netgear, however, I am not entirely convinced it's a client side problem.  The switch sends out a DHCP Discover that looks totally normal to me, and immediately DHCPD replies with an offer for the incorrect address.  Did you look at the packet capture?
Comment 13 Matt Castelein 2009-08-14 16:07:51 EDT
Here is everything I got from Netgear.  It's not much.

 8/6/2009 9:04:00 PM
I have had a problem with this switch not conforming to my DHCP setup.. I have created a host declaration with fixed IP, but each time the switch gets a lease, it''s not given the IP I''ve set up. Now I''ve opened a case with Red Hat about this (https://bugzilla.redhat.com/show_bug.cgi?id=512026), and they''ve decided this is a problem with netgear''s firmware they cannot fix. So here I am.
	8/8/2009 10:15:00 PM
Hello Matt,
Thank you for choosing NETGEAR. My name is Arthur and I will be your support engineer. Since we are doing this online, it may
require a few mail exchanges before we can resolve the issue. We will do our best to help resolve your case in the least
possible time.

First please upgrade the firmware on your FS726T switch to the latest release. You can find the latest firmware at http://kbserver.netgear.com/products/fs726t.asp

We hope that the information provided above will resolve your case. Please feel free to contact us again if you require further
assistance.

Thank you again for choosing NETGEAR. Have a great day!

Sincerely,
Arthur
Agent ID:5669
Business Support Engineer
(US/Canada) 1-888-NETGEAR (Option 4 for Technical Support)
(UK) +44(0)8701 12 1206

**Please be aware that your case will auto-close from our system after 7 days of inactivity**
Please update email support cases through the portal by visiting our web site at: http://my.netgear.com/myNETGEAR/support.asp

	8/9/2009 2:20:00 AM
I have already performed this procedure and the switch is already at the latest firmware version.
	8/12/2009 10:40:00 PM
Hello Matt,

Thank you for choosing NETGEAR. My name is Jacob and I will be your support engineer.

Have you tried to factory default and rebuild your configuration after you did the firmware upgrade?

We hope that the information provided above will resolve your case. Please feel free to contact us again if you require further assistance.


Thank you again for choosing NETGEAR. Have a great day!

Sincerely,
Jacob
Agent ID: 5718
Business Support Engineer
(US/Canada) 888-NETGEAR (Option 4, Option 2)
(UK) +44(0)8701 12 1206

**Please be aware that your case will auto-close from our system after 7 days of inactivity**
Please update email support cases through the portal by visiting our web site at: http://my.netgear.com/myNETGEAR/support.asp
	8/13/2009 12:38:00 AM
Yes, I''ve done that a couple of times. I thought I mentioned that in the Red Hat ticket.. There''s a bunch of info there on what I''ve done so far.
	8/13/2009 3:07:00 AM
Hello Matt,

Thank you for choosing NETGEAR. My name is Ryan and I will be your support engineer.

We have just tested this with the device, with multiple DHCP servers, and it does not seem to be having an issue.

Wireshark is a packet capture we would recommend.

To further narrow this down, please send us a packet capture when the device is getting a DHCP lease.

Thank you again for choosing NETGEAR. Have a great day!

Sincerely,
Ryan J.
Agent ID: 5713
Business Support Engineer
US/Canada 1-888-NETGEAR Option 4 for Technical Support
UK $408701 12 1206

**Please be aware that your case will auto-close from our system after 7 days of inactivity**
Please update email support cases through the portal by visiting our web site at: http://my.netgear.com/myNETGEAR/support.asp
	8/13/2009 12:04:00 PM
Again, this information is already in the ticket which I provided a link to.

Here is a direct link to the capture:
https://bugzilla.redhat.com/attachment.cgi?id=356451
	8/13/2009 9:30:00 PM
Hello Matt,

Thank you for choosing NETGEAR. My name is Ryan and I will be your support engineer.

In looking at the packet capture, we do not see what IP Address the device is assuming, what is that?

Also when using the smart wizard for the device, when you click DHCP Discover, and you login to the device, does it assume the proper IP Address?

Thank you again for choosing NETGEAR. Have a great day!

Sincerely,
Ryan J.
Agent ID: 5713
Business Support Engineer
US/Canada 1-888-NETGEAR Option 4 for Technical Support
UK $408701 12 1206

**Please be aware that your case will auto-close from our system after 7 days of inactivity**
Please update email support cases through the portal by visiting our web site at: http://my.netgear.com/myNETGEAR/support.asp
	8/13/2009 10:58:00 PM
Based on the MAC address, the switch should pick up address 192.168.1.11.. but it gets 192.168.1.101, the first address in the pool for all ''unknown'' devices.
	8/13/2009 11:03:00 PM
Hello Matt,

Thank you for choosing NETGEAR. My name is Ryan and I will be your support engineer.

What about the Smart Wizard tool, does this force the device to the proper IP Address or no ?

Thank you again for choosing NETGEAR. Have a great day!

Sincerely,
Ryan J.
Agent ID: 5713
Business Support Engineer
US/Canada 1-888-NETGEAR Option 4 for Technical Support
UK $408701 12 1206

**Please be aware that your case will auto-close from our system after 7 days of inactivity**
Please update email support cases through the portal by visiting our web site at: http://my.netgear.com/myNETGEAR/support.asp
	8/14/2009 12:58:00 AM
No, it still picks up the .101 address.. It''s as if the MAC address isn''t being recognized on the server.. This product is supposed to be compliant with DHCP standards and of course so is the server, so I don''t see where the mis-communication is getting in.
	8/14/2009 2:57:00 AM
Hello Matt,

Thank you for choosing NETGEAR. My name is Ryan and I will be your support engineer.

The MAC Address you have on the DHCP server for reservation for the switch is 00:14:6C:37:F7:05?

If so, you can see in the packet capture that the device is requesting an IP Address from the DHCP server.

When this occurs, the server responds giving 1.101 IP Address.

This is why I ask if the MAC address of the switch, is what is registered, as if so, then the issue is with the DHCP Server not giving the IP Address to the switch.

In testing this ourselves, with multiple DHCP servers, it has no issues. So verify it is configured correctly, and if so, the DHCP server is the cause of the issue, as you can see in the Packet Capture.

Thank you again for choosing NETGEAR. Have a great day!

Sincerely,
Ryan J.
Agent ID: 5713
Business Support Engineer
US/Canada 1-888-NETGEAR Option 4 for Technical Support
UK $408701 12 1206

**Please be aware that your case will auto-close from our system after 7 days of inactivity**
Please update email support cases through the portal by visiting our web site at: http://my.netgear.com/myNETGEAR/support.asp
	8/14/2009 12:40:00 PM
The relevant entry in dhcpd.conf:

# NETGEAR FS726T
host switch {
hardware ethernet 00:14:6c:37:f7:05;
fixed-address 192.168.1.11;
}

Do you have a Fedora 11 box to test against? I am using dhcp-4.1.0-23.fc11.x86_64
	8/14/2009 12:45:00 PM
The relevant entry in dhcpd.conf:

# NETGEAR FS726T
host switch {
hardware ethernet 00:14:6c:37:f7:05;
fixed-address 192.168.1.11;
}

Do you have a Fedora 11 box to test against? I am using dhcp-4.1.0-23.fc11.x86_64
	8/14/2009 12:47:00 PM
The relevant entry in dhcpd.conf:

# NETGEAR FS726T
host switch {
hardware ethernet 00:14:6c:37:f7:05;
fixed-address 192.168.1.11;
}

Do you have a Fedora 11 box to test against? I am using dhcp-4.1.0-23.fc11.x86_64
	8/14/2009 1:08:00 PM
The relevant entry in dhcpd.conf:

# NETGEAR FS726T
host switch {
hardware ethernet 00:14:6c:37:f7:05;
fixed-address 192.168.1.11;
}

Do you have a Fedora 11 box to test against? I am using dhcp-4.1.0-23.fc11.x86_64
	8/14/2009 8:01:00 PM
Hello Matt,

Thank you for choosing NETGEAR. My name is Ryan and I will be your support engineer.

Unfortunately we do not have a Fedora Box to test with, however if you have it configured right, which you do on the DHCP server, and in looking at the packet capture, the MAC address is the one you verified, it is still assigning the switch 1.101 which is where the problem is.

I don't understand why they would close your ticket regarding it, as if all is correct, the packet capture clearly shows being assigned 1.101 to that MAC Address after it is requesting it. I would reopen the ticket, and with configuration and the packet capture, unless there is a command missing on the DHCP server, then it should be working for you.

Thank you again for choosing NETGEAR. Have a great day!

Sincerely,
Ryan J.
Agent ID: 5713
Business Support Engineer
US/Canada 1-888-NETGEAR Option 4 for Technical Support
UK $408701 12 1206

**Please be aware that your case will auto-close from our system after 7 days of inactivity**
Please update email support cases through the portal by visiting our web site at: http://my.netgear.com/myNETGEAR/support.asp
Comment 14 Matt Castelein 2009-08-14 16:12:13 EDT
I'm curious to see if this switch will do the same thing with other DHCP servers.. I have a CentOS box to test against at the office.  I'll try it next week.
Comment 15 David Cantrell 2009-08-14 17:06:49 EDT
Looking at the packet capture again, I don't see any issues that stand out.  If Netgear is maintaining that it's not a problem on their end, the only thing I think you can try is messing around with dhcpd.conf.  Looking at that again, I would suggest trying the following:

1) Removing 'dynamic-bootp' from the range statement.
2) Comment out all allow and deny lines.
3) Comment out the authoritative line.

There are no error messages from dhcpd that you provided and the configuration file seems valid, but according to the documentation I think the dynamic-bootp option on the range statement may be confusing dhcpd.  Of course, the documentation there is a bit difficult to get through and just find the answer.

That's about all I can think of.  If you do determine that there is a bug in dhcpd, please reopen the ticket.  However, Bugzilla isn't a support tool and there's not much else I can do at this time.

Good luck.
Comment 16 Matt Castelein 2009-08-14 21:15:49 EDT
I'm puzzled.. I've deleted all the active leases, and remove all the free ranges, and set not to allow unknown clients.   The server should now give the switch .11 or simply fail, if I'm understanding the docs right.  But it's still giving .101.. Is there a super-secret place this lease is stored?
Comment 17 Matt Castelein 2009-08-18 19:13:52 EDT
Yes, this turned out to be my fault; Some shuffling of the config file and all is well.

Note You need to log in before you can comment on or make changes to this bug.